package id.co.sangkuriang.inovasi.daerah.master.service

import id.co.sangkuriang.inovasi.daerah.master.model.request.ApplicationCategoryRequest
import id.co.sangkuriang.inovasi.daerah.master.model.request.DeleteDataRequest
import id.co.sangkuriang.inovasi.daerah.master.model.request.PaginationRequest
import id.co.sangkuriang.inovasi.daerah.master.model.response.ReturnData
import org.hibernate.validator.internal.metadata.aggregated.ReturnValueMetaData
import org.springframework.http.ResponseEntity
import javax.servlet.http.HttpServletRequest

interface ApplicationCategoryService {

    fun getAll(page: PaginationRequest): ResponseEntity<ReturnData>

    fun getDetail(id: String): ResponseEntity<ReturnData>

    fun saveData(request: ApplicationCategoryRequest, httpServletRequest: HttpServletRequest): ResponseEntity<ReturnData>

    fun updateData(
        id: String,
        request: ApplicationCategoryRequest,
        httpServletRequest: HttpServletRequest
    ): ResponseEntity<ReturnData>

    fun deleteData(request: DeleteDataRequest, httpServletRequest: HttpServletRequest): ResponseEntity<ReturnData>

    fun count(): ResponseEntity<ReturnData>
}
