package id.co.sangkuriang.inovasi.daerah.master.service

import id.co.sangkuriang.inovasi.daerah.master.model.request.DeleteDataRequest
import id.co.sangkuriang.inovasi.daerah.master.model.request.Pagination2Request
import id.co.sangkuriang.inovasi.daerah.master.model.request.PaginationRequest
import id.co.sangkuriang.inovasi.daerah.master.model.response.ReturnData
import id.co.sangkuriang.inovasi.daerah.master.pojo.Province
import org.springframework.http.ResponseEntity
import javax.servlet.http.HttpServletRequest

interface ProvinceService {

    fun getAll(page: PaginationRequest): ResponseEntity<ReturnData>

    fun getDetail(id: String): ResponseEntity<ReturnData>

    fun saveData(request: Province): ResponseEntity<ReturnData>

    fun updateData(id: String, request: Province): ResponseEntity<ReturnData>

    fun deleteData(request: DeleteDataRequest, httpServletRequest: HttpServletRequest): ResponseEntity<ReturnData>

    fun datatable(req: Pagination2Request): ResponseEntity<ReturnData>

    fun getByName(name: String): ResponseEntity<ReturnData>

    fun count(): ResponseEntity<ReturnData>
}
